#include <bits/stdc++.h>
using namespace std;
long niz[1000005];
long upit(long l, long r)
{
    long i, ret = niz[l];
    for(i = l; i <= r; i++) ret = niz[i]&ret;
    return ret;
}
int main()
{
    ios_base::sync_with_stdio(false);
    long n, i, q, l, r;
    cin >> n >> q;
    for(i = 1; i <= n; i++) cin >> niz[i];
    for(i = 0; i < q; i++)
    {
        cin >> l >> r;
        cout << upit(l, r) << endl;
    }
    return 0;
}